function DataParser(tar, vid) {
  var srcData;
  var dstData = {};
  if (typeof tar === "string") {
    try {
      srcData = JSON.parse(tar);
      var vidl = srcData.data.vidl;
      dstData.id = vid;
      var dstdataurls = [];
      for (var i in vidl) {
        if (!vidl[i].hasOwnProperty("fileFormat")) {
          var dstdataurl = {};
          dstdataurl.url = vidl[i].m3u;
          dstdataurl.quality = vidl[i].screenSize;
          dstdataurls.push(dstdataurl);
        }
      }
      dstData.urls = dstdataurls;
      var dstDataStr = JSON.stringify(dstData);
      returnResultToJava(dstDataStr);
    } catch (error) {
      returnResultToJava("");
    }
  } else {
    returnResultToJava("");
  }
}

function getIqiyiUrl(vid, ts, sc, src) {
  $.get(
    "http://cache.m.iqiyi.com/tmts/" +
    vid +
    "/" +
    vid +
    "/?t=" +
    ts +
    "&sc=" +
    sc +
    "&src=" +
    src,
    function (data, status) {
      DataParser(data, vid);
    }
  ).fail(function () {
    returnResultToJava("");
  });
}

function buildIqiyiPara(vid) {
  var key = "d5fb4bd9d50c4be6948c97edd7254b0e";
  var src = "76f90cbd92f94a2e925d83e8ccd22cb7";
  var ts = new Date().getTime();
  var sc = md5(ts + key + vid);
  getIqiyiUrl(vid, ts, sc, src);
}
function iqiyi(vid) {
  buildIqiyiPara(vid);
}
