var headersTest = "{\"Referer\":\" https://www.mgtv.com\",\"User-Agent\":\" Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3586.0Safari/537.36\"}"


function uuid() {
  var s = [];
  var hexDigits = "0123456789abcdef";
  for (var i = 0; i < 36; i++) {
    s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
  }
  s[14] = "4"; // bits 12-15 of the time_hi_and_version field to 0010
  s[19] = hexDigits.substr((s[19] & 0x3) | 0x8, 1); // bits 6-7 of the clock_seq_hi_and_reserved to 01
  s[8] = s[13] = s[18] = s[23] = "-";

  var uuid = s.join("");
  return uuid;
}

function getRealUrl(url, mycallback) {
  console.log("getRealUrl");
  $.getJSON(url + "&callback=?", function (result) {
    try {
      mycallback(result.info);

    } catch (error) {
      mycallback("");
    }
  }).fail(function () {
    mycallback("");
  });
}

function getSource(pm2, video_id) {
  $.getJSON(
    "https://pcweb.api.mgtv.com/player/getSource" +
    "/?pm2=" +
    pm2 +
    "&video_id=" +
    video_id +
    "&callback=?",
    function (result) {
      try {
        console.log("getSource  0");
        console.log("getSource  :" + result);
        console.log("https://pcweb.api.mgtv.com/player/getSource" +
          "/?pm2=" +
          pm2 +
          "&video_id=" +
          video_id +
          "&callback=?");
        console.log(video_id);

        var dstData = {};
        dstData.id = video_id;
        var streams = result.data.stream;
        var dstdataurls = [];
        var count = 0;
        var stream_domains = result.data.stream_domain;
        if(!stream_domains) {
          returnResultToJava("");
          return;
        }
        
        var stream_domain = "";
        for (var i in stream_domains){
           if(stream_domains[i]!=null && stream_domains[i].replace(/(^s*)|(s*$)/g, "").length!=0){
             stream_domain = stream_domains[i];
             break;
            }
        }
        if(stream_domain == "") {
          returnResultToJava("");
          return;
        }

        var size = streams.length;
          for (var i in streams) {
            console.log(i);
            var dstdataurl = {};
            if(streams[i].url==null || streams[i].url.replace(/(^s*)|(s*$)/g, "").length==0){
              size--;
              if(size==0){
                returnResultToJava("");
              }
              continue;
            }
            getRealUrl(
              stream_domain + streams[i].url
              , function (realurl) {
                dstdataurl.url = realurl;
                dstdataurl.quality = streams[i].name;
                dstdataurl.headers = headersTest;
                if (dstdataurl.url != null && dstdataurl.url != "") {
                  dstdataurls.push(dstdataurl);
                }
                count++;
                console.log(count);
                console.log(streams.length);
                console.log(realurl);
                if (1 == count) {
                  if (dstdataurls.length != 0) {
                    dstData.urls = dstdataurls;
                    var dstDataStr = JSON.stringify(dstData);
                    returnResultToJava(dstDataStr);
                  } else {
                    returnResultToJava("");
                  }

                }
              });
          }
      } catch (error) {
        returnResultToJava("");
      }
    }
  ).fail(function () {
    returnResultToJava("");
  });
}

function getVideo(video_id, tk2) {
  var mgtvVideoUrl = "https://pcweb.api.mgtv.com/player/video" + "/?tk2=" + tk2 + "&video_id=" + video_id + "&callback=?";
  $.getJSON(
    mgtvVideoUrl,
    function (result) {
      if (result && result.data && result.data.atc && result.data.atc.pm2) {
        getSource(result.data.atc.pm2, video_id);
      } else {
        returnResultToJava("");
      }
    }
  )
    .fail(function () {
      console.log("getVideo error");
      returnResultToJava("");
    })
}

function mgtv(vid) {
  var tk2 = $.base64
    .encode(
      "did=" + uuid() + "|pno=1030|ver=0.3.0301|clit=" + new Date().getTime()
    )
    .split("")
    .reverse()
    .join("");
  var video_id = 8296828;
  if (vid > 0) {
    video_id = vid;
  }
  console.log("mgtv  :" + video_id + " ");
  getVideo(video_id, tk2);
}
